package cn.com.qmth.stmms.admin.thread;

import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import cn.com.qmth.stmms.biz.exam.model.ExamQuestion;
import cn.com.qmth.stmms.biz.lock.LockService;
import cn.com.qmth.stmms.biz.mark.service.MarkService;
import cn.com.qmth.stmms.common.enums.LockType;

public class QuestionDeleteThread implements Runnable {

    protected static Logger log = LoggerFactory.getLogger(QuestionDeleteThread.class);

    private List<ExamQuestion> list;

    private ExamQuestion question;

    private MarkService markService;

    private LockService lockService;

    public QuestionDeleteThread(List<ExamQuestion> list, MarkService markService, LockService lockService) {
        this.list = list;
        this.markService = markService;
        this.lockService = lockService;
    }

    @Override
    public void run() {
        if (list == null || list.isEmpty()) {
            return;
        }
        try {
            question = list.get(0);
            lockService.waitlock(LockType.EXAM_SUBJECT, question.getExamId(), question.getSubjectCode());
            markService.deleteByQuestion(list);
        } catch (Exception e) {
            log.error("delete group error", e);
        } finally {
            lockService.unlock(LockType.EXAM_SUBJECT, question.getExamId(), question.getSubjectCode());
            lockService.unlock(LockType.QUESTION_DELETE, question.getExamId(), question.getSubjectCode(),
                    question.getMainNumber(), question.getSubNumber());
        }
    }

}
